[HDU 1087 Super Jumping! Jumping! Jumping!] DP

来源:互联网 发布:js split方法 编辑:程序博客网 时间:2024/03/29 04:39

题目链接 http://acm.hdu.edu.cn/showproblem.php?pid=1087

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 28121    Accepted Submission(s): 12546


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 

Output
For each case, print the maximum according to rules, and one line one case.
 

Sample Input
3 1 3 24 1 2 3 44 3 3 2 10
 

Sample Output
4103
 

Author
lcy
 
简单的来说求的是最大递增子序列和,状态转移方程可以由01背包转化过来,脑洞大的稍微猜一下就能猜出来了。。

直接贴代码吧。。

#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;int t;int val[1010];int dp[1010];void init(){    memset(val, 0, sizeof(val));    memset(dp, 0, sizeof(dp));}int main(){//    freopen("input.txt", "r", stdin);    int n;    while (scanf("%d", &n)!=EOF&&n)    {        init();        for (int i = 1; i <= n; i++){            scanf("%d", &val[i]);            dp[i] = val[i];         //这步必须要        }        int mx = val[1];        for (int i = 1; i <= n; i++)            for (int j = n; j - i >= 0; j--)                if (val[j] > val[i]){        //因为是递增序列                    dp[j] = max(dp[j], dp[i] + val[j]);                    mx = max(mx, dp[j]);                }        printf("%d\n", mx);    }    return 0;}


0 0
原创粉丝点击